config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  resources :mail_bodies
  resources :public_templates

  resources :projects do
    resources :transactions
    resources :templates
    resources :sending_emails
    resources :sending_providers_projects
  end

  root to: 'application#home'
  devise_for :users, :controllers => {:registrations => "registrations"}
  resources :users

  # pages
  get 'home', to: 'application#home'
  get '/dev_mailbox', to: 'dev_mailbox#index'
  get '/projects/:project_id/confirm_sending_emails', to: 'sending_emails#confirm_email'
  get '/projects/:project_id/sending_emails/:id/resend_confirmation', to: 'sending_emails#resend_confirmation'
  get '/projects/:project_id/transactions/:id/design', to: 'transactions#design'
  get '/projects/:id/api_security', to: 'projects#api_security'
  get '/projects/:project_id/create_from_provider/:sending_provider_id', to: 'sending_providers_projects#create_from_provider'

  # vue widget Api
  scope '/projects/:project_id/widjet/v1' do
    # designer endpoint
    scope '/designer' do
      post '/preview', to: 'api/widjet/designer#preview'
      post '/:designable_type/:id/upload_picture_asset', to: 'api/widjet/designer#create_local_picture_asset'
      post '/upload_picture_asset', to: 'api/widjet/designer#create_global_picture_asset'
      patch '/:designable_type/:id', to: 'api/widjet/designer#update_designable'
      delete '/delete_asset/:sendable_asset_id', to: 'api/widjet/designer#destroy_asset'
    end

    # Api security endpoint
    scope '/api_security' do
      post '/create_key/:env', to: 'api/widjet/api_security#generate_key'
      patch '/change_locks/:id', to: 'api/widjet/api_security#change_locks'
    end
  end

  # client Api endpoints
  scope '/v1', defaults: {format: :json} do
    post '/transmit/:code_name', to: 'api/v1/transmit_api#transmit_transaction'
  end


end

app/models/project.rb
class Project < ApplicationRecord
  belongs_to :user
  has_many :transactions, dependent: :destroy
  has_many :templates, dependent: :destroy
  has_many :sending_providers_projects, dependent: :destroy
  has_many :sending_emails, dependent: :destroy
  has_many :defaulties, dependent: :destroy
  has_many :project_api_keys, dependent: :destroy
  has_one :picture, as: :illustrable, dependent: :destroy
  has_many :sendable_assets, as: :attachable, dependent: :destroy

  validates :name, uniqueness: { scope: :user_id }

  # nested attributes
  accepts_nested_attributes_for :picture, reject_if: :all_blank, allow_destroy: true

  def logo scale = :thumb
    if self.picture
      self.picture.illustration scale
    else
      "default_logo.jpg"
    end
  end

  def get_defaulty defaulty_type
    self.defaulties.get_defaulty(self.id, defaulty_type)
  end

  def get_default_of defaulty_type
    defaultables = Object.const_get(defaulty_type).where(project_id: self.id)
    defaulty = self.get_defaulty defaulty_type
    if  defaulty
      defaultables.find(defaulty.defaultable_id)
    else
      defaultables.first
    end
  end

  def has_as_default? defaultable
    result = false
    if self.get_default_of(defaultable.class.name) == defaultable
      result = true
    end
    return result
  end

  def get_dev_key
    key = self.project_api_keys.find_by(for_production: false)

    key || ProjectApiKey.new(for_production: false)
  end

  def get_prod_key
    key = self.project_api_keys.find_by(for_production: true)

    key || ProjectApiKey.new(for_production: true)
  end

  def generate_send_api_dev_key
    current_key = self.get_dev_key
    if self.get_dev_key.id == nil
      ProjectApiKey.generate_keys self, false
    else
      current_key.change_locks
    end
  end

  def generate_send_api_prod_key
    current_key = self.get_prod_key
    if current_key.id == nil
      ProjectApiKey.generate_keys self, true
    else
      current_key.change_locks
    end
  end

  def change_locks_send_api_dev
    self.get_dev_key.change_locks
  end

  def change_locks_send_api_prod
    self.get_prod_key.change_locks
  end

  def unused_smtp_providers
    results = []
    providers = self.sending_providers_projects.map{|a| SendingProvider.find(a.sending_provider_id)}
    SendingProvider.all.each do |sp|
      if providers.exclude? sp
        results << sp
      end
    end
    return results
  end

  def provider_credentials
    self.get_default_of("SendingProvidersProject").get_credentials
  end

end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_project, except: [:index, :create, :new]
  layout :set_layout

  # GET /projects
  # GET /projects.json
  def index
    @projects = current_user.projects
  end

  # GET /projects/1
  # GET /projects/1.json
  def show
  end

  def api_security
    @dev_key = @project.get_dev_key
    @prod_key = @project.get_prod_key
  end

  # GET /projects/new
  def new
    @project = Project.new
    @pic = Picture.new
  end

  # GET /projects/1/edit
  def edit
    @pic = Picture.new
    if @project.picture
      @pic = @project.picture
    end
  end

  # POST /projects
  # POST /projects.json
  def create
    @project = current_user.projects.build(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to @project, notice: 'Project was successfully created.' }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /projects/1
  # PATCH/PUT /projects/1.json
  def update
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to @project, notice: "Project was successfully updated." }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1
  # DELETE /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: "Project was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
      authorize! :crud, @project
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def project_params
      params.require(:project).permit(
          :user_id, :name, :descrpition, :url_to_project,
          picture_attributes: [:illustration]
      )
    end

    def set_layout
      case action_name
      when "new", "index"
        "pages"
      else
        "projects"
      end
    end

end

app/helpers/projects_helper.rb
module ProjectsHelper

  def project_nav_items
    [
        {label: "Project overview", path:  project_path(@project)},
        {label: "Sending email addresses", path: project_sending_emails_path(@project)},
        {label: "Transaction mails", path:  project_transactions_path(@project)},
        {label: "API security", path: "/projects/#{@project.id}/api_security"},
        {label: "Production service providers", path: project_sending_providers_projects_path(@project)}
    ]
  end

  def project_nav_link label, path, current_path
    active_result = link_to label, path, html_options = {class: "nav-link active"}

    if current_path == path
      active_result
    elsif path != project_path(@project) && current_path.include?(path)
      active_result
    else
      link_to label, path, html_options = {class: "nav-link"}
    end
  end

  def highlight_default bool
    if bool
      content_tag(:i, "check_circle", class: "material-icons", style: "color: #63b5f3")
    end
  end

  def highlight_confirmation bool
    if bool
      content_tag(:i, "check_box", class: "material-icons", style: "color: #40ba51")
    else
      content_tag(:i, "indeterminate_check_box", class: "material-icons", style: "color: #c2c2c2")
    end
  end

  def minify_content content
    content.gsub(/\n/, '').gsub(/\t/, '').gsub(/ +\n/, '').gsub(/  +/, ' ')
  end

end

app/views/projects/_form.html.haml
= simple_form_for @project do |f|
  - if @project.errors.any?
    #error_explanation
      %h2= "#{pluralize(@project.errors.count, 'error')} prohibited this project from being saved:"
      %ul
        - @project.errors.full_messages.each do |message|
          %li= message

  .field
    = f.label :name
    = f.text_field :name
  .field
    = f.label :descrpition
    = f.text_area :descrpition
  .field
    = f.simple_fields_for :picture, @pic do |pic|
      = pic.input :illustration, as: :file, label: 'logo'

  .field
    = f.label :url_to_project
    = f.text_field :url_to_project
  .actions
    = f.submit 'Save', class: "btn basic"

app/views/projects/api_security.html.haml
%h1.secure_font API Connection & Security
%br
#ApiSecuritySection.row{ data: {projectid: @project.id, devkey: @dev_key.computed_json, prodkey: @prod_key.computed_json} }
  %br
  %br
  .col-sm-6{"v-for": "key in keyRing"}
    / if there is a key saved
    .card{"v-if":"!!key.id"}
      .card-header{":id": "'card-header-' + key.env_name"}
        %h3
          %b {{key.env_name}}
          enviroment key
        %h5
          %i active since
          %b {{updatedAt(key.updated_at)}}

      .card-body{":id": "'card-body-' + key.env_name"}
        %h5.secure_font
          %b client_id
        .client_id
          {{key.client_id}}
        %hr

        %h5.secure_font
          %b RSA Public key
        %pre.rsa_pub
          {{key.public_key}}
        %hr

        %button.btn.btn-info Need help?

        .text-right
          %a.destroylight{":data-target" => "'#warninglock' + key.id", "data-toggle" => "modal"}
            Change Locks
            %i.material-icons autorenew
            %i.material-icons vpn_key
            \...
        / warning modal before changing locks
        .modal.fade{":id" => "'warninglock' + key.id", "aria-hidden" => "true", "aria-labelledby" => "exampleModalLabel", :role => "dialog", :tabindex => "-1"}
          .modal-dialog{:role => "document"}
            .modal-content
              .modal-header
                %h4.secure_font.modal-title Sure you want to change your {{key.env_name}} keys?
                %button.close{"aria-label" => "Close", "data-dismiss" => "modal", :type => "button"}
                  %span{"aria-hidden" => "true"} ×

              .modal-body
                If you change your locks, the current
                %i secret_keys
                that should be configured
                in your {{key.env_name}} environment won't be valid anymore.
                %br
                %br
                Until you configure the new key (that we gonna povide if you proceed...)
                %b all send request to our API in your {{key.env_name}} environment won't be authorized!
                %br
                %br
                Also be aware that we don't store
                %i secret keys
                \. We only store the your
                %i client_id
                and
                %i public_key
                %br
                %b If you lose any secret key consider it lost!
                %br
                The only way to access our send API is by changing the locks again
                and store the newly provided
                %i secret_key
                In your project's environment variables.
                %br
                %a.btn.btn-info
                  Need some help with that? click here.

              .modal-footer
                %button.btn.basic{"data-dismiss" => "modal", :type => "button"} No, keep my current keys!
                %button.btn.btn-danger{"data-dismiss" => "modal", :type => "button", "v-on:click" => "changeLocks(key.id)"} Yes change my locks...

    / if no key saved
    .card{"v-else":""}
      .card-header{":id": "'card-header-' + key.env_name"}
        %h3
          %b No {{key.env_name}}
          key yet created...

        %hr

        .text-center
          %button.btn.btn-outline-primary.cta{"v-on:click": "generateKey(key.env_name)"}
            create a
            %b {{key.env_name}}
            now!
        %br

  /reveal modal
  %button#revealSecretBtn.btn.btn-primary{"data-target" => "#revealSecret", "data-toggle" => "modal", "data-backdrop" => "static", "hidden" => true}
    Launch demo modal

  #revealSecret.modal.fade{"aria-hidden" => "true", "aria-labelledby" => "exampleModalLabel", :role => "dialog", :tabindex => "-1"}
    .modal-dialog{:role => "document"}
      .modal-content
        %div{"v-if":"!!revealed_key"}
          .modal-header
            %h4.secure_font.modal-title
              New
              %b {{revealed_key.env_name}}
              enviroment key
            %button.close{"aria-label" => "Close", "data-dismiss" => "modal", :type => "button"}
              %span{"@click":"cleanSecret()"} ×

          .modal-body
            %h5.secure_font
              %b your new client_id
              %button.btn.btn-warning{"@click":"copyKey('client_id')"}
                copy
            .client_id
              {{revealed_key.client_id}}

            %hr
            %h5.secure_font
              %b your new RSA secret key
              %button.btn.btn-warning{"@click":"copyKey('secret_key')"}
                copy
            .rsa_secret
              {{revealed_key.secret_key}}
          .modal-footer
            %a#ddlcsv.button.btn.basic{disabled: "true"}
              Get this in a CSV file
            %button.btn.btn-secondary{"@click":"cleanSecret()"} Close


        .modal-body{"v-else":""}
          =image_tag "loading.gif"
          %button#closeRevalation.btn.btn-secondary{"data-dismiss" => "modal", :type => "button", "hidden" => true} Close

app/views/projects/edit.html.haml
%h1 Editing project
%hr

= render 'form'

= link_to 'Show', @project
\|
= link_to 'Destroy', @project, method: :delete, data: { confirm: 'Are you sure?' }
\|
= link_to 'Back', projects_path

app/views/projects/index.html.haml
%h1
  Your projects
  = link_to 'New Project', new_project_path, class: "btn btn-outline-primary cta"
%hr
%div.row
  - @projects.each do |project|
    %div.col-md-3.col-xs-6.text-center.projects
      =link_to project do
        %div.project_btn
          =image_tag project.logo, class: 'logo'
          %h3= project.name
      %a{ href: project.url_to_project, title: "check the project", target: "_blank" }
        check the project
      \|
      = link_to 'Edit', edit_project_path(project)

app/views/projects/new.html.haml
%h1 New project
%hr

= render 'form'

= link_to 'Back', projects_path

app/views/projects/show.html.haml
%p
  %b Name:
  = @project.name
%p
  %b Descrpition:
  = @project.descrpition
%p
  %b Url to project:
  = @project.url_to_project

= link_to 'Edit', edit_project_path(@project)
\|
= link_to 'Back', projects_path